; MemLib v1.0
; written on PlusShell v1.0a
; by Philippe Gervaise aKa CandyMan (candyman@i-france.com)
; (Program structure by Alban Gervaise)
; Enjoy comments in my part :)
; last update: 6th avril 1999


        include "tios.h"    ; we only want ot use ti OS function
        include "exec.inc"

        xdef _ti89          ; heu...it's a ti89!
        xdef _nostub        ; don't need any kernel!!!


_DEREF macro                ; so must write deref MACRO
 lsl.w #2,\1
 GET_REL_RAM_DWORD $2f,$104+$16,\2
 move.l 0(\2,\1.w),\2
 endm

GET_REL_RAM_DWORD macro
 move.l ($c8),a5
 add.l #\1*4,a5
 move.l (a5),a5
 move.l \2(a5),\3
 endm

_begin                         ; same hearder as asm prog
        bra _main              ; address to main
        cnop 0,4
        dc.b "68kP"
        dc.w 0
        dc.w _comment-_begin
        dc.w _main-_begin
        dc.w 0,3,0,0,0,0,0,0,0,0,0,0

max_func                        ; _begin+38
        dc.w 05                 ; number of the last function

exec_table                      ; table of the functions:                               
        dc.l version_str     
        bra.l version        
        dc.l text_nline_str
        bra.l text_nline
        dc.l get_text_line_str
        bra.l get_text_line
        dc.l get_file_byte_str
        bra.l get_file_byte
        dc.l set_file_byte_str
        bra.l set_file_byte


; 1 version function

version_str      dc.b "Version",0      ; func 000


; mem functions...

text_nline_str     dc.b "TextNLine",0    ; func 001
get_text_line_str  dc.b "GetTextLine",0  ; func 002
get_file_byte_str  dc.b "GetFileByte",0  ; func 003
set_file_byte_str  dc.b "SetFileByte",0  ; func 004




_main   lea.l var_name(pc),a0          ; first: search "b_l"
        bsr search_bis
        tst.w d0                       ; d0=0=> no "b_l"
        beq.b \cont
        pea.l nofound(pc)
        bra.b disp
\cont
        move.l a0,vat                  ; d0!=0=> a0=adress of the vat of "b_l"
        move.w 12(a0),d0
        _DEREF d0,a0
        lea 3(a0),a0
        move.l a0,addr
        move.l #2000,-(a7)             ; check if have 2000 bytes...
        ROM_CALL romfunc::HeapAlloc
        lea 4(a7),a7
        tst.w d0
        bne.b ok
mem     pea.l memory(pc)
disp    ROM_CALL romfunc::ST_showHelp
        lea 4(a7),a7
        rts                            ; no so leave...
ok      move.w d0,handle
        _DEREF d0,a1
        move.l a1,str                  ; yes so put the adress of the memory in str
restart move.l addr,a0
        move.l str,a1

\loop   tst.b (a0)
        beq.s \bon                     ; prepare the id string
        cmp.b #58,(a0)
        beq.s \bon
        cmp.b #124,(a0)
        beq.s \bon
        move.b (a0)+,(a1)+
        bra.b \loop  
\bon    clr.b (a1)
        lea.l exec_table(pc),a0
        move.w max_func,d7

\loopd7 movem.l a0/d7,-(a7)           ; main loop
        move.l (a0),d0
        lea.l _begin(pc),a0
        add.l d0,a0
        move.l a0,-(a7)
        move.l str,-(a7)
        ROM_CALL romfunc::strcmp       ; check if function string exists
        lea 8(a7),a7
        movem.l (a7)+,a0/d7
        tst.w d0
        beq lance                      ; yes so launch it
        lea.l 8(a0),a0
        dbra.s d7,\loopd7
        bra exit
lance   jmp 4(a0)                      ; jmp to the adress


;-----------------------------------------------------------------------------
; fonction 000: VERSION
;
; return the version of MemLib (here v1.0)
;-----------------------------------------------------------------------------

version lea.l _comment(pc),a0
        move.l str,a1
\loop   move.b (a0),(a1)+
        tst.b (a0)+
        bne.s \loop
        bra make_string

;-----------------------------------------------------------------------------
; fonction 001: "TextNLine"
;
; Author : Philippe Gervaise aKa CandyMan
; E-Mail : candyman@i-france.com
; Idea   : Mahendra Tallur (mahendra.tallur@laposte.fr)
;
; Get the number of lines of a text (TEXT)
; Parameters : 1
;   Filename (string)
; Output :
;   Number of lines in the text 'FileName'
;-----------------------------------------------------------------------------
text_nline
	move.l addr,a0              ;Pointer to start of command (TextNLine)
	lea.l 10(a0),a0             ;Go to first parametre (TextNLine lenght is 9)
	bsr search_bis              ;Search the parameter file
	tst.w d0                    ;File found ?? (d0 = 0)
	bne exit                    ;File not found, exit with Error code (0)

      move.w 12(a0),d0            ;Get file handle

	_DEREF d0,a0                ;Go to file data

	move.w (a0)+,d1             ;Get text size
	sub.w #5,d1                 ;Search in TextSize - 5 bytes

	lea.l 2(a0),a0              ;Skip Current Position in text

	move.w #1,d0                ;d0 -> Number of lines
NextChar2:
	cmp.b #13,(a0)+             ;New line ?
	bne NoNewLine2              ;No -> Do nothing
	add.w #1,d0                 ;Yes -> Inc number of lines
NoNewLine2

	dbra.w d1,NextChar2         ;Is there again some bytes ?

	bra convert_string          ;Finished, Convert d0 to string

;-----------------------------------------------------------------------------
; fonction 029: GetTextLine
;
; Author : Philippe Gervaise aKa CandyMan
; E-Mail : candyman@i-france.com
; Idea   : Mahendra Tallur (mahendra.tallur@laposte.fr)
;
; Retrieve a line from a text (TEXT)
; Parameters : 2
;   Filename (string)
;   Line Number (number, 1-?????)
; Output :
;   Wanted line number
;-----------------------------------------------------------------------------
get_text_line
	move.w #2,d0                ;Get parameter n2
	bsr GetParam                ;Execute function
	cmp.l #0,a0                 ;Execution successfull ?
	beq exit                    ;Not enough parameters !!

	bsr convert_nbr             ;Convert parameter 2 into number
	move.l d0,-(a7)             ;Save parameter 2 (number)

	move.l addr,a0              ;Pointer to start of command (GetTextLine)
	lea.l 12(a0),a0             ;Go to first parametre (GetTextLine lenght is 11)
	bsr search_bis              ;Search the parameter file

	move.l (a7)+,d2             ;Get line number to retrieve

	tst.w d0                    ;File found ?? (d0 = 0)
	bne exit                    ;File not found, exit with Error code (0)

	move.w 12(a0),d0            ;Get file handle

	_DEREF d0,a0                ;Go to file data
	move.w (a0)+,d1             ;Get text size
	sub.w #5,d1                 ;Search in TextSize - 5 bytes

	lea.l 3(a0),a0              ;Skip Current Position in text and new line space

	move.w #1,d0                ;d0 -> Number of lines
NextChar:
	cmp.w d0,d2                 ;Line is the one to be copied ?
	beq CopyLine                ;If yes -> Copy line

	cmp.b #13,(a0)+             ;New line ?
	bne NoNewLine               ;No -> Do nothing
	add.w #1,d0                 ;Yes -> Inc number of lines
	addq #1,a0                  ;Skip space (For ':' in the TI)
NoNewLine

	dbra.w d1,NextChar          ;Is there again some bytes ?

	bra exit                    ;Then Exit with error (no line found)

CopyLine:
	move.l str,a1               ;Get destination string address

CopyNextChar:
	cmp.b #13,(a0)              ;End of line ?
	beq EndOfString             ;if yes -> End of copy

	move.b (a0)+,(a1)+          ;Copy current char
	dbra.w d1,CopyNextChar      ;Again some bytes to copy ?

EndOfString:
	move.b #0,(a1)              ;Put the char #0 in the string (end of string)

	bra make_string             ;Exit with the 'str' string

;-----------------------------------------------------------------------------
; fonction 030: GetFileByte
;
; Author : Philippe Gervaise aKa CandyMan
; E-Mail : candyman@i-france.com
;
; Retrieve a byte from a file
; Parameters : 2
;   Filename (string)
;   Offset (from the beginning of the file)
;-----------------------------------------------------------------------------
get_file_byte:
	move.w #2,d0                ;Get parameter n2
	bsr GetParam                ;Execute function
	cmp.l #0,a0                 ;Execution successfull ?
	beq exit                    ;Not enough parameters !!

	bsr convert_nbr             ;Convert parameter n2 into a number
	move.l d0,-(a7)             ;Save parameter 2 (number)

	move.l addr,a0              ;Pointer to start of command (GetTextLine)
	lea.l 12(a0),a0             ;Go to first parametre (GetFileByte lenght is 11)
	bsr search_bis              ;Search the parameter file

	move.l (a7)+,d2             ;Get parameter n2 before exiting if file does not exist

	tst.w d0                    ;File found ?? (d0 = 0)
	bne exit                    ;File not found, exit with Error code (0)

	move.w 12(a0),d0            ;Get file handle
	_DEREF d0,a1                ;Go to file data

	move.w (a1)+,d1             ;Get File size
	sub.w #1,d1                 ;Get real data size


	cmp.w d1,d2                 ;Value out of range ?
	bhi exit                    ;Yes -> Exit with error

	add.w d2,a1                 ;Go to desired offset
	clr.w d0                    ;Clear all bits in d0 (highest byte also ...)
	move.b (a1),d0              ;Retrieve the byte

	bra convert_string          ;Return the byte


;-----------------------------------------------------------------------------
; fonction 031: SetFileByte
;
; Author : Philippe Gervaise aKa CandyMan
; E-Mail : candyman@i-france.com
;
; Set a byte in a file
; Parameters : 2
;   Filename (string)
;   Offset (from the beginning of the file)
;   Value (0-255)
; Output :
;   '0' on error, '1' if successfull
;-----------------------------------------------------------------------------
set_file_byte:
	move.w #3,d0                ;Get parameter n3
	bsr GetParam                ;Execute function
	cmp.l #0,a0                 ;Execution successfull ?
	beq exit                    ;Not enough parameters !!

	bsr convert_nbr             ;Convert parameter n3 into a number
	move.l d0,-(a7)             ;Save parameter 3 (number)

	move.w #2,d0                ;Choose parameter n2
	bsr GetParam                ;Get parameter n2
	bsr convert_nbr             ;Convert parameter n2 at a0 into d0
	move.l d0,-(a7)             ;Save parameter 2 (number)

	move.l addr,a0              ;Pointer to start of command (GetTextLine)
	lea.l 12(a0),a0             ;Go to first parametre (GetFileByte lenght is 11)
	bsr search_bis              ;Search the parameter file

	move.l (a7)+,d2             ;Get parameter n2 before exiting if file does not exist
	move.l (a7)+,d3             ;Get parameter n3 before exiting if file does not exist

	tst.w d0                    ;File found ?? (d0 = 0)
	bne exit                    ;File not found, exit with Error code (0)

	move.w 12(a0),d0            ;Get file handle
	_DEREF d0,a1                ;Go to file data

	move.w (a1)+,d1             ;Get File size
	sub.w #1,d1                 ;Get real data size

	cmp.w d1,d2                 ;Value out of range ?
	bhi exit                    ;Yes -> Exit with error

	add.w d2,a1                 ;Go to desired offset
	move.b d3,(a1)              ;Set the byte

	bra good                    ;Return good code

;-----------------------------------------------------------------------------
; fonctions auxiliaires: (other functions...)
;
; GetParam   : Get parameter number d0
; copy_string: copie un string en le coupant apres un 124 ou un 0
; pxl_do     : affiche un pixel
; convert_nbr: converti un nombre sous forme de string en un nombre mis dans d0
; make_string: cree un list avec les string contenus dans str
; search     : cherche une variable avec son nom
; search_bis : cherche une variable avec son nom et son folder
;-----------------------------------------------------------------------------

;===============================================================================
;Any comment, mail to candyman@i-france
;Input : 
;	addr    : Address of current function (Variable)
;	dc.w d0 : Get parameter nb d0 (0-n), 0 is the function name
;Output :
;	dc.l a0 : Address of current parameter (a0 = 0 on error)
;
;Registers destroyed :
;	d1, d2, a0
;===============================================================================
GetParam:
	move.l addr,a0              ;Get parameter string
	tst.w d0                    ;Get parameter number 0 ?
	beq ParamOK                 ;If yes, a0 is good

SearchParam1:
	cmp.b #':',(a0)+            ;End of function name ?
	bne SearchParam1            ;if no -> Scan next character

;Now a0 is a pointer to the first parameter

	move.w #1,d2                ;Current Parameter (first)

ScanParam:
	cmp.w d0,d2                 ;Current parameter is the one required ?
	beq ParamOK                 ;if yes, exit

	add.w #1,d2                 ;Go to next parameter

GoToNextParam:
	move.b (a0)+,d1             ;Retrieve current character

	tst.b d1                    ;End of string ?
	beq ParamError              ;If yes -> Error !!

	cmp.b #'|',d1               ;No more parameters ?
	beq ParamError              ;If yes -> Error !!

	cmp.b #',',d1               ;End of current parameter ?
	bne GoToNextParam           ;If no continue scanning string

	bra ScanParam               ;Next parameter

ParamError:
	move.l #0,a0                ;Error -> Set string address to 0

ParamOK:
	rts

;===============================================================================
;===============================================================================

convert_string:
        move.l str,a0
        lea 5(a0),a0
        clr.b (a0)
        moveq #4,d1
print_loop:
        divu #10,d0
        swap d0
        add.b #48,d0
        move.b d0,-(a0)
        clr.w d0
        swap d0
        dbra.b d1,print_loop
        bra make_string


convert_nbr:            ; input: a0.l = adresse ou se trouve le string a convertir) / output: d0.w = nombre
        move.l a0,a1
        clr.w d1
\loopn  add.w #1,d1
        add.l #1,a1
        tst.b (a1)
        beq.s \begin
        cmp.b #',',(a1)
        beq.s \begin
        cmp.b #124,(a1)
        bne.s \loopn
\begin  sub.w #1,d1
        clr.w d0
\loop   mulu #10,d0
        add.b (a0)+,d0
        sub.w #48,d0
        dbra.s d1,\loop
        rts

make_string:
        move.l vat,a0
        move.w 12(a0),-(a7)
        ROM_CALL romfunc::HeapFree  ; on libere l'ancienne handle
        lea 2(a7),a7
        move.l str,-(a7)
        ROM_CALL romfunc::strlen    ; on veut la taille de str
        lea 4(a7),a7
        move.w d0,taille

        move.l str,a0
\loop   tst.b (a0)
        beq \bon
        cmp.b #':',(a0)+
        bne.S \loop
        add.w #2,taille
        bra.S \loop
\bon    clr.l d0
        move.w taille,d0
        add.l #7,d0
        move.l d0,-(a7)
        ROM_CALL romfunc::HeapAlloc
        lea 4(a7),a7
        move.l vat,a0
        move.w d0,12(a0)
        _DEREF d0,a0
        move.w taille,d0
        move.w d0,(a0)
        add.w #5,(a0)+
        move.w #$e500,(a0)+
        move.l str,a2
\copy   tst.b (a2)
        beq.b \fin
        cmp.b #':',(a2)
        beq.b \chg
        move.b (a2)+,(a0)+
        bra.b \copy
\chg    clr.B (a0)+
        move.b #45,(a0)+
        clr.b (a0)+
        add.l #1,a2
        bra.b \copy
\fin    clr.b (a0)+
        move.b #45,(a0)+
        move.b #217,(a0)

clr_str move.w handle,-(a7)
        ROM_CALL romfunc::HeapFree
        lea 2(a7),a7
        rts

; SEARCH BIS
; fonction: cherche l'adresse d'une variable a partir de son nom et de son folder
; Ex : 'main\tst', if it's only 'tst' (then there isn't have any '\') execute search
; input  : a0 = adresse du nom
; output : a0 = adresse de la vat
;          d0.w = 0 si trouve

search_bis
	movem.l a1-a6/d1-d7,-(a7)
	move.l a0,a1                ;Save string address into a1
	lea FolderName(PC),a3       ;Get FolderName address in a3
\mode
	move.b (a1)+,(a3)           ;Copy char from Input to FolderName
	tst.b (a3)                  ;End of string ?
	beq FileMode                ;Yes -> Put file mode (no folder)

	cmp.b #',',(a3)             ;End of parameter ?
	beq FileMode                ;Yes -> Put file mode (no folder)

	cmp.b #'|',(a3)             ;End of function ?
	beq FileMode                ;Yes -> Put file mode (no folder)

	cmp.b #'\',(a3)             ;Found '\' ??
	beq DirMode                 ;If yes, retrieve filename

	addq #1,a3                  ;'\' not found, next char
	bra \mode                   ;'\' not found, -> Copy next char

FileMode:
	move.b #0,(a3)              ;Put a end of string to FolderName
	lea FolderName(PC),a3       ;Get FolderName address in a3
	lea FileName(PC),a4         ;Get FileName address in a4
\strcpy
	move.b (a3),(a4)+           ;Copy FolderName into FileName
	tst.b (a3)+                 ;End of string for FolderName ?
	bne \strcpy                 ;No -> Continue copying

	move.w #1,taille            ;Engage file mode (No folder)
	bra endcopy2                ;Now, search file

DirMode:
	move.b #0,(a3)              ;Put a end of string to FolderName
	move.w #0,taille            ;Engage Folder mode (Folder present)
	lea FileName(PC),a3         ;Get FileName address in a3

\copy2
	move.b (a1)+,(a3)           ;Copy filename to variable FileName

	cmp.b #',',(a3)             ;End of parameter ?
	beq EndFileCopy             ;Yes -> Terminate copy

	cmp.b #'|',(a3)             ;End of function ?
	beq EndFileCopy             ;Yes -> Terminate copy

	tst.b (a3)                  ;End of string ?
	beq endcopy2                ;If yes, stop copy

	addq #1,a3                  ;Next char
	bra \copy2                  ;Copy next character

EndFileCopy:
	move.b #0,(a3)              ;Put a end of string in FileName

endcopy2
	moveq #8,d1                 ;Get folder list handle
	_DEREF d1,a1                ;a1 -> pointer to Folder list
	move.w 2(a1),d1             ;Get number of folders
	sub.w #1,d1
	lea 4(a1),a1                ;Go to first folder description (name)
NextFolder
	tst.w taille                ;File Mode ?
	bne \apres                  ;<> 0 -> File Mode engage -> Check files in this folder

	movem.l a0-a6/d1-d7,-(a7)
	move.l a1,-(a7)
	pea FolderName(PC)
	ROM_CALL romfunc::strcmp
	lea 8(a7),a7
	movem.l (a7)+,a0-a6/d1-d7
	tst.w d0
	beq \apres
	lea 14(a1),a1
	dbra.s d1,NextFolder
	beq fini2

\apres
	move.w 12(a1),d0            ;Get Current folder Handle
	_DEREF d0,a0                ;Get pointer to file list
	move.w 2(a0),d7             ;Get number of files
	tst.w d7                    ;Is there any files ?
	beq SkipFolder              ;No -> Skip this folder

	sub.w #1,d7
	lea 4(a0),a0                ;Go to the first file descriptor (name)
NextFile:
	movem.l a0-a6/d1-d6,-(a7)
	movem.l a0,-(a7)
	pea FileName(PC)
	ROM_CALL romfunc::strcmp
	lea 8(a7),a7
	movem.l (a7)+,a0-a6/d1-d6

	tst.w d0                    ;File found ?
	beq fini2                   ;Yes -> End of routine
	lea 14(a0),a0               ;No -> Go to the next file descriptor
	dbra.s d7,NextFile          ;Is there again some files ?

SkipFolder:
	lea 14(a1),a1               ;Go to the next folder descriptor
	dbra d1,NextFolder          ;Is there again some folders ?
fini2:
	movem.l (a7)+,a1-a6/d1-d7
	rts

;-----------------------------------------------------------------------------
; fonctions de sortie:
;
;exit (une erreur s'est produite): retourne un "0" dans b_l
;good (la foncion a ete executee): retourne un "1" dans b_l
;-----------------------------------------------------------------------------

exit    move.l str,a0
        move.B #'0',(a0)+
do_mv   clr.b (a0)
        bra make_string
good    ROM_CALL OSClearBreak/4
        move.l str,a0
        move.b #'1',(a0)+
        move.l addr,a1
\loop   tst.b (a1)
        beq.b do_mv
        cmp.b #124,(a1)+
        bne.s \loop
        move.l a1,addr
        bra restart

taille           dc.w 0

FolderName		dc.b "philippe",0,0
FileName		dc.b "gervaise",0,0

var_name		dc.b "b_l",0
memory			dc.b "not enough memory",0
nofound		dc.b "can't find b_l",0,0

addr             dc.l 0    ; adresse du fichier d b_l
vat              dc.l 0    ; adresse de la vat de b_l
str              dc.l 0    ; adresse de str
handle           dc.w 0    ; handle de str

_comment         dc.b "by Philippe Gervaise:v1.0:MemLib",0

; each ":" means that it is a element in a list

 end